unit Main;

interface

uses
  SysUtils, Wintypes,Winprocs, Messages, Classes, Graphics, Controls,IniFiles,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, Spin, Grids,
  Hw_16, TabNotBk;

type
  TMainForm = class(TForm)
    BitBtn3: TBitBtn;
    Panel1: TPanel;
    Label4: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    TabbedNotebook1: TTabbedNotebook;
    Timer1: TTimer;
    L_Gen: TLabel;
    Label2: TLabel;
    Label5: TLabel;
    L_Timers: TLabel;
    Label7: TLabel;
    L_Handled: TLabel;
    L_H: TLabel;
    B_SetIRQ: TButton;
    B_Mask: TButton;
    SpinIRQ: TSpinEdit;
    B_Pulse: TButton;
    Label1: TLabel;
    S_Interval: TSpinEdit;
    Label12: TLabel;
    E_Addr: TEdit;
    B_ReadMemory: TButton;
    MemoHex: TStringGrid;
    G_Read: TGroupBox;
    Label3: TLabel;
    Label10: TLabel;
    RPin1: TCheckBox;
    RPin2: TCheckBox;
    RPin3: TCheckBox;
    RPin4: TCheckBox;
    RPin5: TCheckBox;
    RPin6: TCheckBox;
    Rpin7: TCheckBox;
    RPin8: TCheckBox;
    RPin9: TCheckBox;
    RPin10: TCheckBox;
    RPin11: TCheckBox;
    RPin12: TCheckBox;
    RPin13: TCheckBox;
    RPin14: TCheckBox;
    RPin15: TCheckBox;
    RPin16: TCheckBox;
    RPin17: TCheckBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    GroupBox1: TGroupBox;
    Label11: TLabel;
    Label13: TLabel;
    WPin1: TCheckBox;
    WPin2: TCheckBox;
    WPin3: TCheckBox;
    WPin4: TCheckBox;
    WPin5: TCheckBox;
    WPin6: TCheckBox;
    WPin7: TCheckBox;
    WPin8: TCheckBox;
    WPin9: TCheckBox;
    WPin14: TCheckBox;
    WPin15: TCheckBox;
    WPin17: TCheckBox;
    WPin10: TCheckBox;
    WPin11: TCheckBox;
    WPin12: TCheckBox;
    WPin13: TCheckBox;
    WPin16: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    CheckBox16: TCheckBox;
    GroupBox2: TGroupBox;
    C_BUSY: TCheckBox;
    C_PE: TCheckBox;
    C_ERROR: TCheckBox;
    C_Init: TButton;
    B_Print: TButton;
    B_Stop: TButton;
    TextMemo: TEdit;
    AllLines: TSpinEdit;
    L_lines: TLabel;
    Label14: TLabel;
    HWCtrl: TVicHw16;
    VicLPT: TVicLPT16;
    GroupBox3: TGroupBox;
    L_LPTs: TComboBox;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    GroupBox4: TGroupBox;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    C_LPTs: TComboBox;
    C_IRQ: TCheckBox;
    procedure FormActivate(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure HWCtrlHwInterrupt(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure B_SetIRQClick(Sender: TObject);
    procedure B_MaskClick(Sender: TObject);
    procedure SpinIRQChange(Sender: TObject);
    procedure B_PulseClick(Sender: TObject);
    procedure B_ReadMemoryClick(Sender: TObject);
    procedure B_PrintClick(Sender: TObject);
    procedure B_WriteAllPinsClick(Sender: TObject);
    procedure B_StopClick(Sender: TObject);
    procedure C_InitClick(Sender: TObject);
    procedure L_LPTsChange(Sender: TObject);
    procedure C_IRQClick(Sender: TObject);
  end;

const MaxPorts = 16;

var
  MainForm: TMainForm;


implementation

{$R *.DFM}

type T256 = array[1..16,1..16] of Byte;

var  Flag_tim,Flag_Intr,MaxInterval  : LongInt;
     Sum_Ticks,CurrTicker, OldTicker : Longint;
     PhysAddr                        : Longint;
     PointPhys                       :^T256;
     FlagPrint                       : Boolean;
     NumLine,NumSymbol               : Word;

var CPinRead,CPinWrite : array[1..25] of TCheckBox;

function HexToInt(s:String):Longint;
const hexch:array[0..15] of Char='0123456789ABCDEF';
var i,j : Byte;
    r,n,k:Longint;
    ch : Char;
begin
  k:=1; r:=0;
  for i:=Length(s) downto 1 do
  begin
    ch:=s[i]; n:=0;
    for j:=0 to 15 do if UpperCase(ch)=hexch[j] then n:=j;
    r:=r+n*k; if i>1 then k:=k*16;
  end;
  Result:=r;
end;


procedure ShowButtons;
begin
  with MainForm,HwCtrl do
  begin
   SpinIRQ.Enabled:=not IsIRQSet;
   B_SetIRQ.Enabled:=TRUE;
   if IsIRQSet then B_SetIRQ.caption:='Destroy IRQ'
               else B_SetIRQ.caption:='Set IRQ';
   B_Pulse.Enabled:=IsIRQSet and Masked;
   B_Mask.Enabled:=IsIRQSet;
   if Masked then B_Mask.caption:='Unmask IRQ'
             else B_Mask.caption:='Mask IRQ';
  end;
end;

procedure TMainForm.FormActivate(Sender: TObject);
var MyIniFile : TIniFile;
    i         : Word;
begin

 with VicLPT,MyIniFile,HWCtrl do
 begin

   L_LPTs.ItemIndex:=LongInt(LPT);
   C_LPTs.ItemIndex:=LongInt(LPT);
   VicLPT.IRQEnabled:=C_IRQ.Checked;

   Label15.caption:='$'+IntToHex(BasePort,4);
   Label16.caption:='$'+IntToHex(StatusPort,4);
   Label17.caption:='$'+IntToHex(CommandPort,4);
   Label21.caption:='$'+IntToHex(BasePort,4);
   Label22.caption:='$'+IntToHex(StatusPort,4);
   Label23.caption:='$'+IntToHex(CommandPort,4);

   CPinRead[ 1]:=RPin1;    CPinWrite[ 1]:=WPin1;
   CPinRead[ 2]:=RPin2;    CPinWrite[ 2]:=WPin2;
   CPinRead[ 3]:=RPin3;    CPinWrite[ 3]:=WPin3;
   CPinRead[ 4]:=RPin4;    CPinWrite[ 4]:=WPin4;
   CPinRead[ 5]:=RPin5;    CPinWrite[ 5]:=WPin5;
   CPinRead[ 6]:=RPin6;    CPinWrite[ 6]:=WPin6;
   CPinRead[ 7]:=RPin7;    CPinWrite[ 7]:=WPin7;
   CPinRead[ 8]:=RPin8;    CPinWrite[ 8]:=WPin8;
   CPinRead[ 9]:=RPin9;    CPinWrite[ 9]:=WPin9;
   CPinRead[10]:=RPin10;   CPinWrite[10]:=WPin10; WPin10.Enabled:=FALSE;
   CPinRead[11]:=RPin11;   CPinWrite[11]:=WPin11; WPin11.Enabled:=FALSE;
   CPinRead[12]:=RPin12;   CPinWrite[12]:=WPin12; WPin12.Enabled:=FALSE;
   CPinRead[13]:=RPin13;   CPinWrite[13]:=WPin13; WPin13.Enabled:=FALSE;
   CPinRead[14]:=RPin14;   CPinWrite[14]:=WPin14;
   CPinRead[15]:=RPin15;   CPinWrite[15]:=WPin15; WPin15.Enabled:=FALSE;
   CPinRead[16]:=RPin16;   CPinWrite[16]:=WPin16;
   CPinRead[17]:=RPin17;   CPinWrite[17]:=WPin17;


   MyInifile:=TIniFile.Create('HW_test.ini');


   PhysAddr:=ReadInteger('misc','ADDR',$F8000);
   E_Addr.Text:=IntToHex(PhysAddr,8);
   IRQNumber:=ReadInteger('misc','IRQ',10);
   SpinIRQ.Value:=IRQNumber;

   with MemoHex do
   begin
     Cells[0,0]:='  ADDR';
     Cells[1,0]:='             HEX';
     Cells[2,0]:='     ASCII';
   end;
   ShowButtons;
   MyIniFile.Free;
   ShowButtons;
 end;
end;

procedure TMainForm.BitBtn3Click(Sender: TObject);
var MyIniFile : TIniFile;
    i         : Word;
begin
 MyInifile:=TIniFile.Create('HW_test.ini');
 with MyIniFile,HWCtrl  do
 begin
  WriteInteger('misc','ADDR',PhysAddr);
  WriteInteger('misc','IRQ',IRQNumber);
 end;
 MyIniFile.Free;
 Close;
end;

procedure TMainForm.HWCtrlHwInterrupt(Sender: TObject);
begin
  Inc(Flag_Intr);
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
var nPin : Byte;
    s : String;
    i : Word;
begin
  with HWCtrl,VicLPT do
  begin
    L_Gen.Caption:=IntToStr(IRQCounter);
    L_Handled.Caption:=IntToStr(Flag_Intr);
    L_Timers.Caption:=IntToStr(Flag_tim div 1000);
    if IsIRQSet and not Masked then
    begin
      CurrTicker:=GetTickCount;
      Flag_Tim:=Sum_Ticks+CurrTicker-OldTicker;
    end else  OldTicker:=GetTickCount;
    if (MaxInterval<=Flag_Tim) and (MaxInterval>0) and (not Masked) then
    begin
      MaskInterrupt; ShowButtons;
    end;

    B_Stop.Enabled:=FlagPrint;
    B_Print.Enabled:=not FlagPrint;

    for nPin:=1 to 17 do CPinRead[nPin].Checked:=Pin[nPin];

    C_BUSY.Checked :=BUSY;
    C_PE.Checked   :=PE;
    C_ERROR.Checked:=_ERROR;

    while FlagPrint do
    begin
        Timer1.Enabled:=FALSE;
        s:=IntToStr(NumLine)+' - '+TextMemo.Text+#$0A#$0D;
        Application.ProcessMessages;
        if NumSymbol>Length(s) then
        begin
          Inc(NumLine);
          NumSymbol:=1;
          FlagPrint:=NumLine<=AllLines.Value;
          if not FlagPrint then Break;
          continue;
        end;
        if PrintChar(s[NumSymbol]) then Inc(NumSymbol);
    end;

  end;

  Timer1.Enabled:=TRUE;

end;

procedure TMainForm.B_SetIRQClick(Sender: TObject);
begin
  with HWCtrl do
  begin
    IRQNumber:=SpinIRQ.Value;
    Flag_tim:=0;
    if not IsIRQSet  then  SetIRQ(HWCtrl)
                     else  DestroyIRQ;
    Sum_Ticks:=0;
    Flag_Intr:=0;
    ShowButtons;
  end;
end;

procedure TMainForm.B_MaskClick(Sender: TObject);
begin
  with HWCtrl do
  begin
    if not Masked then
    begin
      MaskInterrupt;
      Sum_Ticks:=Flag_Tim;
    end
    else begin MaxInterval:=S_Interval.Value*1000; UnmaskInterrupt; end;
    ShowButtons;
  end;
end;

procedure TMainForm.SpinIRQChange(Sender: TObject);
begin
  HWCtrl.IRQNumber:=SpinIRQ.Value;
end;

procedure TMainForm.B_PulseClick(Sender: TObject);
begin
  HwCtrl.SimulateHwInt;
end;

procedure TMainForm.B_ReadMemoryClick(Sender: TObject);
var CurrAddr,i,j : Longint;
    s            : String;
    b            : Byte;
    ch           : Char;
begin
  PhysAddr:=HexToInt(E_Addr.text); E_Addr.Text:=IntToHex(PhysAddr,8);
  with HwCtrl do PointPhys:=MapPhysMemory(PhysAddr,256);
  if PointPhys<>NIL then
  begin
    CurrAddr:=PhysAddr;
    for i:=1 to 16 do
    begin
      s:=IntToHex(CurrAddr,8); MemoHex.Cells[0,i]:=s; s:='';
      for j:=1 to 16 do s:=s+IntToHex(PointPhys^[i][j],2);
      MemoHex.Cells[1,i]:=s; s:='';
      for j:=1 to 16 do
      begin
        b:=PointPhys^[i][j];
        if b>=$20 then ch:=Char(b) else ch:='.';  s:=s+ch;
      end;
      MemoHex.Cells[2,i]:=s;
      CurrAddr:=CurrAddr+16;
    end;

  end;


end;

procedure TMainForm.B_PrintClick(Sender: TObject);
begin
  VicLPT._INIT;
  NumSymbol:=1;
  NumLine:=1;
  FlagPrint:=TRUE;
end;

procedure TMainForm.B_WriteAllPinsClick(Sender: TObject);
var nPin:Byte;
begin
  for npin:=1 to 17 do VicLPT.Pin[nPin]:=CPinWrite[nPin].Checked;
end;

procedure TMainForm.B_StopClick(Sender: TObject);
begin
  FlagPrint:=FALSE;
end;

procedure TMainForm.C_InitClick(Sender: TObject);
begin
  VicLPT._INIT;
end;

procedure TMainForm.L_LPTsChange(Sender: TObject);
begin
 with VicLPT do
 begin
  LPT:=TLPTNumber((Sender as TComboBox).ItemIndex);
  L_LPTs.ItemIndex:=LongInt(LPT);
  C_LPTs.ItemIndex:=LongInt(LPT);
  Label15.caption:='$'+IntToHex(BasePort,4);
  Label16.caption:='$'+IntToHex(StatusPort,4);
  Label17.caption:='$'+IntToHex(CommandPort,4);
  Label21.caption:='$'+IntToHex(BasePort,4);
  Label22.caption:='$'+IntToHex(StatusPort,4);
  Label23.caption:='$'+IntToHex(CommandPort,4);
  if BasePort=0 then
  begin
    MessageBeep(0);
    ShowMessage('This LPT-address do not exist!');
  end;
 end;
end;

procedure TMainForm.C_IRQClick(Sender: TObject);
begin
  VicLPT.IRQEnabled:=C_IRQ.Checked;
end;

initialization
  Flag_Intr:=0; Flag_tim   := 0;
  Sum_Ticks:=0; CurrTicker := 0;
  OldTicker:=0;
  FlagPrint:=FALSE;
  NumSymbol:=0;
end.
